# uxn-grid

Do monome grid I/O with uxn!

## Building

```
make
```
requires libmonome.

## Usage

use `in` as the uxn input, and `out` as the uxn output:
```
./in /dev/ttyACM0 | uxnemu test.rom | ./out /dev/ttyACM0 
```

`in` outputs grid events as three bytes (state, x, and y). See examples/basic.tal for a uxn example of handling this

output messages have the same arguments as they do in [monome OSC](https://monome.org/docs/serialosc/osc). Each argument is given as a byte and the message type is a byte. The message types are:

* 0x00: led/set
* 0x01: led/all
* 0x01: led/map
* 0x03: led/row
* 0x04: led/col
* 0x05: led/level/set
* 0x06: led/level/all
* 0x07: led/level/map
* 0x08: led/level/row
* 0x09: led/level/col

so to send a `led/set 1 2 1` message, send the bytes `0x00 0x01 0x02 0x01` to the out program (if you are using this in a pipe with uxn, this is `.Console/write`)